module IT_MtoP

def self.turn_mesh_to_poly(state)
	model = Sketchup.active_model
	selection = model.selection
	selection = model.active_entities if selection.empty?
	model.start_operation "Mesh to Poly"
	self.process_at_level state, selection, {}
	model.commit_operation
end

def self.process_at_level(state, entities, hcomp)
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			self.process_at_level state, entity.entities, hcomp
		when 'ComponentInstance'
			edef = entity.definition
			next if hcomp[edef.to_s]
			hcomp[edef.to_s] = edef
			self.process_at_level state, edef.entities, hcomp
		when 'Edge'
			if (entity.soft? == true)and(entity.smooth? == true)
			entity.casts_shadows = false
			p '*'
			end
		end
	end
end	
end #module IT_MtoP


if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item ('Mesh to Poly') { IT_MtoP.turn_mesh_to_poly true }
	end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item ('Mesh to Poly') { IT_MtoP.turn_mesh_to_poly true }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)

